# Copyright (c) 2023 Project CHIP Authors
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

name:
    12.4.7. [TC-CNET-4.9] [WiFi] Verification for RemoveNetwork Command
    [DUT-Server]

PICS:
    - CNET.S.F00

config:
    nodeId: 0x12344321
    cluster: "Network Commissioning"
    #PIXIT.CNET.ENDPOINT_WIFI
    endpoint: 0
    PIXIT.CNET.WIFI_1ST_ACCESSPOINT_SSID:
        type: octet_string
        defaultValue: "hex:7A6967626565686F6D65"

tests:
    - label: "Precondition: TH reads FeatureMap attribute from the DUT"
      command: "readAttribute"
      attribute: "FeatureMap"
      response:
          value: 1
          constraints:
              type: bitmap32

    - label:
          "Step 1: TH sends ArmFailSafe command to the DUT with
          ExpiryLengthSeconds set to 900"
      cluster: "General Commissioning"
      command: "ArmFailSafe"
      arguments:
          values:
              - name: "ExpiryLengthSeconds"
                value: 900
              - name: "Breadcrumb"
                value: 0
      response:
          values:
              - name: "ErrorCode"
                value: 0
              - name: "DebugText"
                value: ""

    - label:
          "Step 2: TH reads Networks attribute from the DUT and saves the number
          of entries as 'NumNetworks' "
      PICS: CNET.S.A0001
      command: "readAttribute"
      attribute: "Networks"
      response:
          constraints:
              contains:
                  [
                      {
                          NetworkID: PIXIT.CNET.WIFI_1ST_ACCESSPOINT_SSID,
                          Connected: true,
                      },
                  ]

    - label:
          "Step 3: TH finds the index of the Networks list entry with NetworkID
          field value PIXIT.CNET.WIFI_1ST_ACCESSPOINT_SSID and saves it as
          'Userth_netidx'"
      verification: |
          TH finds the index of the Networks list entry with NetworkID
          field value PIXIT.CNET.WIFI_1ST_ACCESSPOINT_SSID and saves it as
          'Userth_netidx'
      cluster: "LogCommands"
      command: "UserPrompt"
      PICS: PICS_USER_PROMPT
      arguments:
          values:
              - name: "message"
                value: "Please enter 'y' for success"
              - name: "expectedValue"
                value: "y"

    - label:
          "Step 4: TH sends RemoveNetwork Command to the DUT with NetworkID
          field set to PIXIT.CNET.WIFI_1ST_ACCESSPOINT_SSID and Breadcrumb field
          set to 1"
      verification: |
          Verify that DUT sends NetworkConfigResponse to command with the following fields:
          NetworkingStatus is success

          NetworkIndex is 'Userwifi_netidx'
      PICS: CNET.S.C04.Rsp && CNET.S.C05.Tx
      command: "RemoveNetwork"
      arguments:
          values:
              - name: "NetworkID"
                value: PIXIT.CNET.WIFI_1ST_ACCESSPOINT_SSID
              - name: "Breadcrumb"
                value: 1
      response:
          values:
              - name: "NetworkingStatus"
                value: 0
              - name: "NetworkIndex"
                value: 0

    - label: "Step 5: TH reads Networks attribute from the DUT"
      PICS: CNET.S.A0001
      command: "readAttribute"
      attribute: "Networks"
      response:
          constraints:
              type: list
              excludes:
                  [
                      {
                          NetworkID: PIXIT.CNET.WIFI_1ST_ACCESSPOINT_SSID,
                          Connected: true,
                      },
                  ]

    - label: "Step 6: TH reads LastNetworkingStatus attribute from the DUT"
      PICS: CNET.S.A0005
      command: "readAttribute"
      attribute: "LastNetworkingStatus"
      response:
          value: 0
          constraints:
              type: NetworkCommissioningStatusEnum

    - label: "Step 7: TH reads LastNetworkID attribute from the DUT"
      PICS: CNET.S.A0006
      command: "readAttribute"
      attribute: "LastNetworkID"
      response:
          value: PIXIT.CNET.WIFI_1ST_ACCESSPOINT_SSID
          constraints:
              type: octet_string
              minLength: 1
              maxLength: 32

    - label:
          "Step 8: TH reads Breadcrumb attribute from the General Commissioning
          cluster of the DUT"
      PICS: CNET.S.C04.Rsp
      cluster: "General Commissioning"
      command: "readAttribute"
      attribute: "Breadcrumb"
      response:
          value: 1
          constraints:
              type: int64u

    - label:
          "Step 9: TH sends ConnectNetwork command to the DUT with NetworkID
          field set to PIXIT.CNET.WIFI_1ST_ACCESSPOINT_SSID and Breadcrumb field
          set to 2"
      PICS: CNET.S.C04.Rsp && CNET.S.C06.Rsp
      timedInteractionTimeoutMs: 5000
      command: "ConnectNetwork"
      arguments:
          values:
              - name: "NetworkID"
                value: PIXIT.CNET.WIFI_1ST_ACCESSPOINT_SSID
              - name: "Breadcrumb"
                value: 2
      response:
          values:
              - name: "NetworkingStatus"
                value: 3
              - name: "ErrorValue"
                constraints:
                    type: int32s

    - label:
          "Step 10: TH reads Breadcrumb attribute from the General Commissioning
          cluster of the DUT"
      PICS: CNET.S.C04.Rsp
      cluster: "General Commissioning"
      command: "readAttribute"
      attribute: "Breadcrumb"
      response:
          value: 1
          constraints:
              type: int64u

    - label:
          "Step 11: TH sends ArmFailSafe command to the DUT with
          ExpiryLengthSeconds set to 0"
      cluster: "General Commissioning"
      command: "ArmFailSafe"
      arguments:
          values:
              - name: "ExpiryLengthSeconds"
                value: 0
              - name: "Breadcrumb"
                value: 0
      response:
          values:
              - name: "ErrorCode"
                value: 0
              - name: "DebugText"
                value: ""

    - label: "Step 12: TH reads Networks attribute from the DUT"
      PICS: CNET.S.A0001
      command: "readAttribute"
      attribute: "Networks"
      response:
          constraints:
              contains:
                  [
                      {
                          NetworkID: PIXIT.CNET.WIFI_1ST_ACCESSPOINT_SSID,
                          Connected: true,
                      },
                  ]

    - label:
          "Step 13: TH sends ArmFailSafe command to the DUT with
          ExpiryLengthSeconds set to 900"
      cluster: "General Commissioning"
      command: "ArmFailSafe"
      arguments:
          values:
              - name: "ExpiryLengthSeconds"
                value: 900
              - name: "Breadcrumb"
                value: 0
      response:
          values:
              - name: "ErrorCode"
                value: 0
              - name: "DebugText"
                value: ""

    - label:
          "Step 14: TH sends RemoveNetwork Command to the DUT with NetworkID
          field set to PIXIT.CNET.WIFI_1ST_ACCESSPOINT_SSID and Breadcrumb field
          set to 1"
      verification: |
          Verify that DUT sends NetworkConfigResponse to command with the following fields:
          NetworkingStatus is success

          NetworkIndex is 'Userwifi_netidx'
      PICS: CNET.S.C04.Rsp && CNET.S.C05.Tx
      command: "RemoveNetwork"
      arguments:
          values:
              - name: "NetworkID"
                value: PIXIT.CNET.WIFI_1ST_ACCESSPOINT_SSID
              - name: "Breadcrumb"
                value: 1
      response:
          values:
              - name: "NetworkingStatus"
                value: 0
              - name: "NetworkIndex"
                value: 0

    - label: "Step 15: TH sends the CommissioningComplete command to the DUT"
      PICS: CNET.S.C04.Rsp
      cluster: "General Commissioning"
      command: "CommissioningComplete"
      response:
          values:
              - name: "ErrorCode"
                value: 0
              - name: "DebugText"
                value: ""

    - label:
          "Step 16: TH sends ArmFailSafe command to the DUT with
          ExpiryLengthSeconds set to 0 to ensure the CommissioningComplete call
          properly persisted the failsafe context. This call should have no
          effect if Commissioning Complete call is handled correctly"
      cluster: "General Commissioning"
      command: "ArmFailSafe"
      arguments:
          values:
              - name: "ExpiryLengthSeconds"
                value: 0
              - name: "Breadcrumb"
                value: 0
      response:
          values:
              - name: "ErrorCode"
                value: 0
              - name: "DebugText"
                value: ""

    - label: "Step 17: TH reads Networks attribute from the DUT"
      PICS: CNET.S.A0001
      command: "readAttribute"
      attribute: "Networks"
      response:
          constraints:
              type: list
              excludes:
                  [
                      {
                          NetworkID: PIXIT.CNET.WIFI_1ST_ACCESSPOINT_SSID,
                          Connected: true,
                      },
                  ]
